PRINT
PRINT "SPLIT2.EXE V1.00 - 2 Way Splitter for Intel-HEX Files."
PRINT "(C) Copyright 1992 - Paul Stenning, Hereford, England."
PRINT

REM      Last Modified on 13/08/92 - Revision 2

L% = CSRLIN

FILE$ = COMMAND$

CHECK: IF FILE$ = "" THEN
    LOCATE L%, 1
    INPUT "Enter Filename "; FILE$
    IF FILE$ = "" THEN PRINT : END
    GOTO CHECK
    END IF
IF LEN(FILE$) > 8 THEN PRINT "ILLEGAL FILENAME": END
FILE$ = UCASE$(FILE$)
FOR X = 1 TO LEN(FILE$)
IF MID$(FILE$, X, 1) = "." THEN PRINT "ILLEGAL FILENAME": END
NEXT X

PRINT : PRINT "Input File   - "; FILE$; ".HEX"
PRINT "Output Files - "; FILE$; ".EVN and "; FILE$; ".ODD"

ON ERROR GOTO ERROR1
OPEN FILE$ + ".HEX" FOR INPUT AS #1

ON ERROR GOTO ERROR2
OPEN FILE$ + ".EVN" FOR OUTPUT AS #2
OPEN FILE$ + ".ODD" FOR OUTPUT AS #3

PRINT : L% = CSRLIN

COUNT% = 0
LOCATE L%, 1: PRINT "Processing Line ";
ON ERROR GOTO ERROR3

START:
COUNT% = COUNT% + 1: LOCATE L%, 16: PRINT COUNT%;
LINE INPUT #1, A$
ON ERROR GOTO ERROR4
LENGTH% = VAL("&H" + MID$(A$, 2, 2))
CHK% = 0
FOR X = 1 TO LENGTH% + 4: CHK% = CHK% + VAL("&H" + MID$(A$, X * 2, 2)): NEXT
DO WHILE CHK% > 256: CHK% = CHK% - 256: LOOP
CHK% = 256 - CHK%
IF CHK% <> VAL("&H" + RIGHT$(A$, 2)) THEN GOTO ERROR4

IF MID$(A$, 8, 2) <> "00" GOTO FINISH
ADDR& = VAL("&H" + MID$(A$, 4, 4)) / 2
IF ADDR& < 0 THEN ADDR& = ADDR& + 32768
ADDR$ = HEX$(ADDR&)

ADDR: IF LEN(ADDR$) < 4 THEN ADDR$ = "0" + ADDR$: GOTO ADDR
NEWLEN$ = HEX$(LENGTH% / 2): IF LEN(NEWLEN$) = 1 THEN NEWLEN$ = "0" + NEWLEN$
E$ = ":" + NEWLEN$ + ADDR$ + "00"
O$ = ":" + NEWLEN$ + ADDR$ + "00"
E% = LENGTH% / 2 + VAL("&H" + LEFT$(ADDR$, 2)) + VAL("&H" + RIGHT$(ADDR$, 2))
O% = LENGTH% / 2 + VAL("&H" + LEFT$(ADDR$, 2)) + VAL("&H" + RIGHT$(ADDR$, 2))

FOR X = 10 TO (((LENGTH% / 2) - 1) * 4) + 10 STEP 4
E$ = E$ + MID$(A$, X, 2)
O$ = O$ + MID$(A$, X + 2, 2)
E% = E% + VAL("&H" + MID$(A$, X, 2))
O% = O% + VAL("&H" + MID$(A$, X + 2, 2))
NEXT X

DO WHILE E% > 256: E% = E% - 256: LOOP
E% = 256 - E%
IF LEN(HEX$(E%)) = 1 THEN E$ = E$ + "0"
E$ = E$ + HEX$(E%)

DO WHILE O% > 256: O% = O% - 256: LOOP
O% = 256 - O%
IF LEN(HEX$(O%)) = 1 THEN O$ = O$ + "0"
O$ = O$ + HEX$(O%)

ON ERROR GOTO ERROR3
PRINT #2, E$
PRINT #3, O$
GOTO START

FINISH:
PRINT #2, ":00000001FF"
PRINT #3, ":00000001FF"
CLOSE
BEEP
LOCATE L%, 1: PRINT "Completed Successfully."
PRINT
END

ERROR1:
CLOSE
PRINT : PRINT : PRINT "INPUT FILE NOT FOUND": END

ERROR2:
CLOSE
PRINT : PRINT : PRINT "ERROR OPENING OUTPUT FILES": END

ERROR3:
CLOSE
BEEP: BEEP: BEEP
PRINT : PRINT : PRINT "FILE ACCESS ERROR": END

ERROR4:
CLOSE
BEEP: BEEP: BEEP
PRINT : PRINT : PRINT "CHECKSUM ERROR IN INPUT FILE, LINE"; COUNT%: END




