PRINT
PRINT "SPLIT4.EXE V1.00 - 4 Way Splitter for Intel-HEX Files."
PRINT "(C) Copyright 1992 - Paul Stenning, Hereford, England."
PRINT

REM      Last Modified on 13/08/92 - Revision 2

L% = CSRLIN

FILE$ = COMMAND$

CHECK: IF FILE$ = "" THEN
    LOCATE L%, 1
    INPUT "Enter Filename "; FILE$
    IF FILE$ = "" THEN PRINT : END
    GOTO CHECK
    END IF
IF LEN(FILE$) > 8 THEN PRINT "ILLEGAL FILENAME": END
FILE$ = UCASE$(FILE$)
FOR X = 1 TO LEN(FILE$)
IF MID$(FILE$, X, 1) = "." THEN PRINT "ILLEGAL FILENAME": END
NEXT X

PRINT : PRINT "Input File   - "; FILE$; ".HEX"
PRINT "Output Files - "; FILE$; ".111, "; FILE$; ".222, "; FILE$; ".333 and "; FILE$; ".444"

ON ERROR GOTO ERROR1
OPEN FILE$ + ".HEX" FOR INPUT AS #1

ON ERROR GOTO ERROR2
OPEN FILE$ + ".111" FOR OUTPUT AS #2
OPEN FILE$ + ".222" FOR OUTPUT AS #3
OPEN FILE$ + ".333" FOR OUTPUT AS #4
OPEN FILE$ + ".444" FOR OUTPUT AS #5

PRINT : L% = CSRLIN

COUNT% = 0
LOCATE L%, 1: PRINT "Processing Line ";
ON ERROR GOTO ERROR3

START:
COUNT% = COUNT% + 1: LOCATE L%, 16: PRINT COUNT%;
LINE INPUT #1, A$
ON ERROR GOTO ERROR4
LENGTH% = VAL("&H" + MID$(A$, 2, 2))
CHK% = 0
FOR X = 1 TO LENGTH% + 4: CHK% = CHK% + VAL("&H" + MID$(A$, X * 2, 2)): NEXT
DO WHILE CHK% > 256: CHK% = CHK% - 256: LOOP
CHK% = 256 - CHK%
IF CHK% <> VAL("&H" + RIGHT$(A$, 2)) THEN GOTO ERROR4

IF MID$(A$, 8, 2) <> "00" GOTO FINISH
ADDR& = VAL("&H" + MID$(A$, 4, 4)) / 4
IF ADDR& < 0 THEN ADDR& = ADDR& + 32768
ADDR$ = HEX$(ADDR&)

ADDR: IF LEN(ADDR$) < 4 THEN ADDR$ = "0" + ADDR$: GOTO ADDR
NEWLEN$ = HEX$(LENGTH% / 4): IF LEN(NEWLEN$) = 1 THEN NEWLEN$ = "0" + NEWLEN$
e$ = ":" + NEWLEN$ + ADDR$ + "00"
f$ = ":" + NEWLEN$ + ADDR$ + "00"
g$ = ":" + NEWLEN$ + ADDR$ + "00"
h$ = ":" + NEWLEN$ + ADDR$ + "00"

e% = LENGTH% / 2 + VAL("&H" + LEFT$(ADDR$, 2)) + VAL("&H" + RIGHT$(ADDR$, 2))
f% = LENGTH% / 2 + VAL("&H" + LEFT$(ADDR$, 2)) + VAL("&H" + RIGHT$(ADDR$, 2))
g% = LENGTH% / 2 + VAL("&H" + LEFT$(ADDR$, 2)) + VAL("&H" + RIGHT$(ADDR$, 2))
h% = LENGTH% / 2 + VAL("&H" + LEFT$(ADDR$, 2)) + VAL("&H" + RIGHT$(ADDR$, 2))

FOR X = 10 TO (((LENGTH% / 2) - 1) * 4) + 10 STEP 8
e$ = e$ + MID$(A$, X, 2)
f$ = f$ + MID$(A$, X + 2, 2)
g$ = g$ + MID$(A$, X + 4, 2)
h$ = h$ + MID$(A$, X + 6, 2)
e% = e% + VAL("&H" + MID$(A$, X, 2))
f% = f% + VAL("&H" + MID$(A$, X + 2, 2))
g% = g% + VAL("&H" + MID$(A$, X + 4, 2))
g% = g% + VAL("&H" + MID$(A$, X + 6, 2))
NEXT X

DO WHILE e% > 256: e% = e% - 256: LOOP
e% = 256 - e%
IF LEN(HEX$(e%)) = 1 THEN e$ = e$ + "0"
e$ = e$ + HEX$(e%)

DO WHILE f% > 256: f% = f% - 256: LOOP
f% = 256 - f%
IF LEN(HEX$(f%)) = 1 THEN f$ = f$ + "0"
f$ = f$ + HEX$(f%)

DO WHILE g% > 256: g% = g% - 256: LOOP
g% = 256 - g%
IF LEN(HEX$(g%)) = 1 THEN g$ = g$ + "0"
g$ = g$ + HEX$(g%)

DO WHILE h% > 256: h% = h% - 256: LOOP
h% = 256 - h%
IF LEN(HEX$(h%)) = 1 THEN h$ = h$ + "0"
h$ = h$ + HEX$(h%)

ON ERROR GOTO ERROR3
PRINT #2, e$
PRINT #3, f$
PRINT #4, g$
PRINT #5, h$
GOTO START

FINISH:
PRINT #2, ":00000001FF"
PRINT #3, ":00000001FF"
PRINT #4, ":00000001FF"
PRINT #5, ":00000001FF"
CLOSE
BEEP
LOCATE L%, 1: PRINT "Completed Successfully."
PRINT
END

ERROR1:
CLOSE
PRINT : PRINT : PRINT "INPUT FILE NOT FOUND": END

ERROR2:
CLOSE
PRINT : PRINT : PRINT "ERROR OPENING OUTPUT FILES": END

ERROR3:
CLOSE
BEEP: BEEP: BEEP
PRINT : PRINT : PRINT "FILE ACCESS ERROR": END

ERROR4:
CLOSE
BEEP: BEEP: BEEP
PRINT : PRINT : PRINT "CHECKSUM ERROR IN INPUT FILE, LINE"; COUNT%: END




